/***************************************************************************
 *   Copyright (C) 2007 by Erlih Dmitriy   *
 *   mega25@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "glwindow.h"


glwindow::glwindow(QWidget * parent, const char * name, WFlags f)
	: QGLWidget(parent,name,0,f)
{
	pointSize=3;
	lineWidth=2;

	points << QPoint(-200,-200);
	points << QPoint(-200,200);
	points << QPoint(200,-200);
	points << QPoint(200,200);

	setMinimumSize( 400,400);
	setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding );
	show();
}


glwindow::~glwindow()
{
}

void glwindow::resizeGL( int Width, int Height )
{
	glViewport(0,0,(GLint)Width,(GLint)Height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-1,1,-1,1,-1,1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void glwindow::paintGL( )
{
	glClearColor(bgcolor.red()/255.0,bgcolor.green()/255.0,bgcolor.blue()/255.0,0);
	glClear(GL_COLOR_BUFFER_BIT);

	glPointSize(pointSize);
	glLineWidth(lineWidth);

	glBegin(GL_LINES);
	glColor3f(0,0,0);
	glVertex2f(-1,0);
	glVertex2f(1,0);
	glVertex2f(0,-1);
	glVertex2f(0,1);
	glEnd();

	glColor3f(color.red()/255.0, color.green()/255.0, color.blue()/255.0);
	switch(testtype)
	{
		case 0: glEnable(GL_SCISSOR_TEST);glScissor(x,y,h,w);break;
		case 1: glEnable(GL_ALPHA_TEST);glAlphaFunc(transpartype,alfa);break;
		case 2: glEnable(GL_BLEND);glBlendFunc(sfactor,dfactor);break;
	}
	glBegin(GL_QUADS);
	QValueList<QPoint>::iterator it;
	for(it = points.begin();it != points.end();++it)
		glVertex2f( (*it).x()/255.0, (*it).y()/255.0 );
	switch(testtype)
	{
		case 0: glDisable(GL_SCISSOR_TEST);break;
		case 1: glDisable(GL_ALPHA_TEST);break;
		case 2: glDisable(GL_BLEND);break;
	}
	glEnd();

}




void glwindow::setX(const int& theValue)
{
  x = theValue;
}


void glwindow::setY(const int& theValue)
{
  y = theValue;
}


void glwindow::setH(const int& theValue)
{
  h = theValue;
}


void glwindow::setW(const int& theValue)
{
  w = theValue;
}


void glwindow::setTesttype(const int& theValue)
{
  testtype = theValue;
}


void glwindow::setColor(const QColor& theValue)
{
  color = theValue;
}


void glwindow::setBgcolor(const QColor& theValue)
{
  bgcolor = theValue;
}


void glwindow::setTranspartype(const int& theValue)
{
  transpartype = theValue;
}


void glwindow::setAlfa(float theValue)
{
  alfa = theValue;
}


void glwindow::setSfactor(const int& theValue)
{
  sfactor = theValue;
}


void glwindow::setDfactor(const int& theValue)
{
  dfactor = theValue;
}
