/***************************************************************************
 *   Copyright (C) 2007 by Erlih Dmitriy   *
 *   mega25@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLWINDOW_H
#define GLWINDOW_H

#include <qgl.h>
#include <qvaluelist.h>
#include <qpoint.h>

/**
	@author Erlih Dmitriy <mega25@mail.ru>
*/
class glwindow : public QGLWidget
{
public:
	glwindow(QWidget * parent = 0, const char * name = 0, WFlags f = 0);
	~glwindow();

	void setX(const int& theValue);
	void setY(const int& theValue);
	void setH(const int& theValue);
	void setW(const int& theValue);
	void setTesttype(const int& theValue);
	void setColor(const QColor& theValue);
	void setBgcolor(const QColor& theValue);
	void setTranspartype(const int& theValue);
	void setAlfa(float theValue);
	void setSfactor(const int& theValue);
	void setDfactor(const int& theValue);

protected:
	void resizeGL(int Width,int Height);
	void paintGL();

private:
	QValueList<QPoint> points;
	int pointSize,lineWidth;
	QColor color,bgcolor;
	int testtype;
	//glScissor
	int x,y,h,w;
	//glAlphaFunc
	int transpartype;
	float alfa;
	//glBlendFunc
	int sfactor,dfactor;
};

#endif
