/***************************************************************************
 *   Copyright (C) 2007 by Erlih Dmitriy   *
 *   mega25@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "mainwindow.h"
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qspinbox.h>
#include <qbuttongroup.h>
#include <qlcdnumber.h>
#include <qcombobox.h>

mainwindow::mainwindow()
 : QHBox()
{
	tgl = new glwindow(this,"glwindow");
	tmenu = new menu(this,"menu");

	connect(tmenu,SIGNAL(redraw(int)),SLOT(redraw(int)));
	connect(tmenu,SIGNAL(redraw()),SLOT(redraw()));

	setCaption(tr("lab2"));
	redraw();
}


mainwindow::~mainwindow()
{
}

void mainwindow::redraw( )
{
	tgl->setColor(tmenu->color_button->paletteBackgroundColor());
	tgl->setBgcolor(tmenu->bgcolor_button->paletteBackgroundColor());

	tgl->setTesttype(tmenu->tabWidget2->currentPageIndex ());

	tgl->setX(tmenu->spinBox1->value());
	tgl->setY(tmenu->spinBox2->value());
	tgl->setH(tmenu->spinBox3->value());
	tgl->setW(tmenu->spinBox4->value());

	switch(tmenu->buttonGroup1->selectedId())
	{
		case 0: tgl->setTranspartype(GL_NEVER);break;
		case 1: tgl->setTranspartype(GL_LESS);break;
		case 2: tgl->setTranspartype(GL_EQUAL);break;
		case 3: tgl->setTranspartype(GL_LEQUAL);break;
		case 4: tgl->setTranspartype(GL_GREATER);break;
		case 5: tgl->setTranspartype(GL_NOTEQUAL);break;
		case 6: tgl->setTranspartype(GL_GEQUAL);break;
		case 7: tgl->setTranspartype(GL_ALWAYS);break;
	}
	tgl->setAlfa(tmenu->lCDNumber1->value());

	switch(tmenu->comboBox1->currentItem ())
	{
		case 0: tgl->setSfactor(GL_ZERO);break;
		case 1: tgl->setSfactor(GL_ONE);break;
		case 2: tgl->setSfactor(GL_DST_COLOR);break;
		case 3: tgl->setSfactor(GL_ONE_MINUS_DST_COLOR);break;
		case 4: tgl->setSfactor(GL_SRC_ALPHA);break;
		case 5: tgl->setSfactor(GL_ONE_MINUS_SRC_ALPHA);break;
		case 6: tgl->setSfactor(GL_DST_ALPHA);break;
		case 7: tgl->setSfactor(GL_ONE_MINUS_DST_ALPHA);break;
		case 8: tgl->setSfactor(GL_SRC_ALPHA_SATURATE);break;
	}
	switch(tmenu->comboBox2->currentItem())
	{
		case 0: tgl->setDfactor(GL_ZERO);break;
		case 1: tgl->setDfactor(GL_ONE);break;
		case 2: tgl->setDfactor(GL_SRC_COLOR);break;
		case 3: tgl->setDfactor(GL_ONE_MINUS_SRC_COLOR);break;
		case 4: tgl->setDfactor(GL_SRC_ALPHA);break;
		case 5: tgl->setDfactor(GL_ONE_MINUS_SRC_ALPHA);break;
		case 6: tgl->setDfactor(GL_DST_ALPHA);break;
		case 7: tgl->setDfactor(GL_ONE_MINUS_DST_ALPHA);break;
	}

	tgl->updateGL();
}

void mainwindow::redraw( int )
{
	redraw();
}


