/***************************************************************************
 *   Copyright (C) 2007 by Erlih Dmitriy   *
 *   mega25@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "menu.h"
#include <qpushbutton.h>
#include <qapplication.h>
#include <qcolordialog.h>
#include <qbuttongroup.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qspinbox.h>
#include <qcombobox.h>

menu::menu(QWidget* parent, const char* name, WFlags fl)
: Form1(parent,name,fl)
{
	setSizePolicy (QSizePolicy::Fixed,QSizePolicy::Expanding);

	connect(color_button,SIGNAL(clicked()),SLOT(colordialog()));
	connect(bgcolor_button,SIGNAL(clicked()),SLOT(bgcolordialog()));
	connect(pushButton3,SIGNAL(clicked()),qApp,SLOT(quit()));
	connect(buttonGroup1,SIGNAL(clicked(int)),SLOT(alfa(int)));
	connect(slider1,SIGNAL(valueChanged(int)),SLOT(alfachanged(int)));

	connect(spinBox1,SIGNAL(valueChanged(int)),SIGNAL(redraw( int)));
	connect(spinBox2,SIGNAL(valueChanged(int)),SIGNAL(redraw( int)));
	connect(spinBox3,SIGNAL(valueChanged(int)),SIGNAL(redraw( int)));
	connect(spinBox4,SIGNAL(valueChanged(int)),SIGNAL(redraw( int)));

	connect(comboBox1,SIGNAL(activated(int)),SIGNAL(redraw( int)));
	connect(comboBox2,SIGNAL(activated(int)),SIGNAL(redraw( int)));

	alfa(0);
}

menu::~menu()
{
}

void menu::colordialog( )
{
	disconnect(color_button,SIGNAL(clicked()),this,SLOT(colordialog()));
	QColor color = color_button->paletteBackgroundColor();
	color = QColorDialog::getColor(color);
	color_button->setPaletteBackgroundColor(color);
	connect(color_button,SIGNAL(clicked()),SLOT(colordialog()));
	emit redraw();
}

void menu::bgcolordialog( )
{
	disconnect(bgcolor_button,SIGNAL(clicked()),this,SLOT(bgcolordialog()));
	QColor color = bgcolor_button->paletteBackgroundColor();
	color = QColorDialog::getColor(color);
	bgcolor_button->setPaletteBackgroundColor(color);
	connect(bgcolor_button,SIGNAL(clicked()),SLOT(bgcolordialog()));
	emit redraw();
}

void menu::alfa( int)
{
	int i = buttonGroup1->selectedId();
	if(i == 0 || i == 7)
	{
		slider1->setEnabled(0);
		lCDNumber1->setEnabled(0);
	}
	else
	{
		slider1->setEnabled(1);
		lCDNumber1->setEnabled(1);
	}
	emit redraw();
}

void menu::alfachanged( int i)
{
	lCDNumber1->display(i/255.0);
	emit redraw();
}
